/*

gmp_extension.cc -- extension to the GMP float functions for the iRRAM library
 
Copyright (C) 2002 Norbert Mueller
 
This file is part of the iRRAM Library.
 
The iRRAM Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Library General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at your
option) any later version.
 
The iRRAM Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
License for more details.
 
You should have received a copy of the GNU Library General Public License
along with the iRRAM Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA. 
*/

#include "iRRAM.h"
#include "gmp_extension.h"

DYADIC glob_arg;
DYADIC glob_res;
long glob_precision;

void mp_ext_start(mpf_ptr r, mpf_srcptr u,long int p,void proc()){
  mpf_set_prec(glob_arg.value,mpf_get_prec(u));
  mpf_set(glob_arg.value,u);
  glob_precision=p;
  iRRAM_exec(proc);
  mpf_set_prec(r,mpf_get_prec(glob_res.value));
  mpf_set(r,glob_res.value);
}

void compute_test() { glob_res=approx(REAL(glob_arg),glob_precision); }
void mpf_ext_test (mpf_ptr r, mpf_srcptr u, long int p){ mp_ext_start(r,u,p,compute_test); }  

void compute_exp() { glob_res=approx(exp(REAL(glob_arg)),glob_precision); }
void mpf_ext_exp (mpf_ptr r, mpf_srcptr u, long int p){ mp_ext_start(r,u,p,compute_exp); }  

void compute_log() { glob_res=approx(log(REAL(glob_arg)),glob_precision); }
void mpf_ext_log (mpf_ptr r, mpf_srcptr u, long int p){ mp_ext_start(r,u,p,compute_log); }  

void compute_sin() { glob_res=approx(sin(REAL(glob_arg)),glob_precision); }
void mpf_ext_sin (mpf_ptr r, mpf_srcptr u, long int p){ mp_ext_start(r,u,p,compute_sin); }  

void compute_cos() { glob_res=approx(cos(REAL(glob_arg)),glob_precision); }
void mpf_ext_cos (mpf_ptr r, mpf_srcptr u, long int p){ mp_ext_start(r,u,p,compute_cos); }  

void compute_tan() { glob_res=approx(tan(REAL(glob_arg)),glob_precision); }
void mpf_ext_tan (mpf_ptr r, mpf_srcptr u, long int p){ mp_ext_start(r,u,p,compute_tan); }  
