#include "iRRAM.h"
#include "mpfr_extension.h"
#include "mpfr-impl.h"

DYADIC glob_arg;
DYADIC glob_res;
long glob_precision;

void mp_ext_start(mpfr_ptr r, mpfr_srcptr u,long int p,void proc()){
  mpfr_set_prec(glob_arg.value,mpfr_get_prec(u));
  mpfr_set(glob_arg.value,u,__gmp_default_rounding_mode);
  glob_precision=p;
  iRRAM_exec(proc);
  mpfr_set_prec(r,mpfr_get_prec(glob_res.value));
  mpfr_set(r,glob_res.value,__gmp_default_rounding_mode);
}

void compute_test() { glob_res=approx(sin(REAL(glob_arg)),glob_precision); }
void mpfr_ext_test (mpfr_ptr y, mpfr_srcptr u, long int p, mp_rnd_t rnd_mode)
   {
    mpfr_t r;
    mpfr_init(r);
    long err=50;
    if (p< 0) err= p;
    do  {
       err=err-10;
       mp_ext_start(r,u,err,compute_test);
 mpfr_print_binary(r);printf(" %d %d %d\n",MPFR_EXP(r),err,MPFR_EXP(r)+err);
     } while (!  mpfr_can_round(r,MPFR_EXP(r)+err ,GMP_RNDN, rnd_mode, p ));
 
     mpfr_set_prec(y,p);  
     mpfr_set(y,r,rnd_mode);
     
     mpfr_clear(r);
   }  







void compute_exp() { glob_res=approx(exp(REAL(glob_arg)),glob_precision); }
void mpfr_ext_exp (mpfr_ptr r, mpfr_srcptr u, long int p){ mp_ext_start(r,u,p,compute_exp); }  

void compute_log() { glob_res=approx(log(REAL(glob_arg)),glob_precision); }
void mpfr_ext_log (mpfr_ptr r, mpfr_srcptr u, long int p){ mp_ext_start(r,u,p,compute_log); }  

void compute_sin() { glob_res=approx(sin(REAL(glob_arg)),glob_precision); }
void mpfr_ext_sin (mpfr_ptr r, mpfr_srcptr u, long int p){ mp_ext_start(r,u,p,compute_sin); }  

void compute_cos() { glob_res=approx(cos(REAL(glob_arg)),glob_precision); }
void mpfr_ext_cos (mpfr_ptr r, mpfr_srcptr u, long int p){ mp_ext_start(r,u,p,compute_cos); }  

void compute_tan() { glob_res=approx(tan(REAL(glob_arg)),glob_precision); }
void mpfr_ext_tan (mpfr_ptr r, mpfr_srcptr u, long int p){ mp_ext_start(r,u,p,compute_tan); }  
