#include "iRRAM.h"

/* Compute iteration by J.M.Muller */

void jmm_double(int count){
  double a=11.0/2.0, b=61.00/11.0, c;
  for (long i=1;i<=count;i++ ) {
    rprintf("%13.10f",a); rprintf(" %d\n",i);
    c=111-(1130-3000/a)/b;
    a=b; b=c;   
  }
}


void jmm_REAL(int count){
  REAL a= REAL(11)/2, b=REAL(61)/11, c;
  for (long i=1;i<=count;i++ ) {
    rwrite(a,18); rprintf(" %d\n",i);
    c=111-(1130-3000/a)/b;
    a=b; b=c;   
  }
}


void jmm_RATIONAL(int count){
  RATIONAL a=RATIONAL(11)/2, b=RATIONAL(61)/11, c;
  for (long i=1;i<=count;i++ ) {
    rwrite(REAL(a),18); rprintf(" %d\n",i);
    c=111-(1130-3000/a)/b;
    a=b; b=c;   
  }
}



void itsyst_with_INTEGER(int count){


  REAL x = 0.5;

  for ( int i=0; i<=count; i++ ) {
    if ( (i<100) || (i%10)==0 ) {
      rwrite(x,18); rprintf(" %d\n",i);
    }
    x= (x*(1-x)*375)/100;
  }
}


void compute(){
  int test,count;
  rprintf("JMM-example: c=111-(1130-3000/a)/b");
  rprintf("how to compute (1=REAL, 2=double, 3=RATIONAL) : ");
  rscanf("%d",&test);
  rprintf("how many values: ");
  rscanf("%d",&count);
  switch (test) {
     case 1:;
       jmm_REAL(count);
     break;
     case 2:;
       jmm_double(count);
     break;
     case 3:;
       jmm_RATIONAL(count);
     break;
  }


};
